/*
 *	i2c routines (c) by Lucky 2008
 *  
 *
 *
 *
 */


#ifndef ___I2C
#define ___I2C
unsigned char m_TRIS;
#define setTris(x)  { m_TRIS = x; TRISC = m_TRIS;}

#define SCL     RC4 // I2C bus
#define SDA     RC5 //

#define SCL_IN     setTris (m_TRIS | 0b00010000)
#define SCL_OUT    setTris (m_TRIS & 0b11101111)
#define SDA_IN     setTris (m_TRIS | 0b00100000)
#define SDA_OUT    setTris (m_TRIS & 0b11011111)

#define i2c_dly() NOP()
//; NOP()

#ifndef i2c_dly
void i2c_dly(void) {
//   NOP();
//   NOP();
}
#endif
void i2c_start(void) {
   i2c_dly();
   SDA_IN;
   i2c_dly();
   SCL_IN;
   i2c_dly();
   SDA_OUT;
   i2c_dly();
   SCL_OUT;
   i2c_dly();
}

void i2c_stop(void) {
   i2c_dly();
   SDA_OUT;
   i2c_dly();
   SCL_OUT;
   i2c_dly();
   SCL_IN;
   i2c_dly();
   SDA_IN;
   i2c_dly();
}

void i2c_init(void) {
   SCL = 0;
   SCL_OUT;
   SDA = 0;
   SDA_OUT;
   i2c_stop();
   i2c_dly();
}
void i2c_send_bit (unsigned char xy) {
    i2c_dly();
    if(xy&0x01) 
       SDA_IN
    else 
       SDA_OUT;
    i2c_dly();
    SCL_IN;
    i2c_dly();
    while (!SCL);
    i2c_dly();
    SCL_OUT;
    i2c_dly();
}

unsigned char i2c_rx(char ack) {
char x, d=0;
  for(x=0; x<8; x++) {
    d <<= 1;
    i2c_dly();
    SDA_IN;
    i2c_dly();
    SCL_IN;
    i2c_dly();
    while (!SCL);
    i2c_dly();
    if(SDA) 
       d |= 1;
    i2c_dly();
    SCL_OUT;
    i2c_dly();
  } 
  i2c_send_bit (~ack);    
  return d;
}




void i2c_tx(unsigned char d) {
   char x;
  for(x=8; x; x--) { 
    if (d&0x80)
       i2c_send_bit (1);
    else
       i2c_send_bit (0);
    d <<= 1;
  }
  i2c_send_bit (1);
}

#endif